// IOData.cpp:      DLL.

#include "IOData.h"
typedef std::vector<std::string> TStrings;
TStrings Rstrings;
TStrings Sstrings;
#define ERROR -1;
#define EXPFUNC __declspec(dllexport)
BOOL APIENTRY DllMain( HMODULE hModule, DWORD  ul_reason_for_call,  LPVOID lpReserved )
{
	switch (ul_reason_for_call)
	{
    	case DLL_PROCESS_ATTACH:
    	case DLL_THREAD_ATTACH:
    	case DLL_THREAD_DETACH:
    	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

int CurrentStr=0;

EXPFUNC const char * __stdcall InData(int nStr)
{
	const char *res= "no data";
	if((nStr < Rstrings.size())&&(Rstrings.size()>0))
	{
		res = Rstrings[nStr].c_str();
	}
	return(res);
}

EXPFUNC const void  __stdcall OutData(char *data)
{
	Sstrings.push_back(data);
}

//return count string
EXPFUNC int __stdcall RFile(char *filename)
{
	int res=ERROR;
    const int BUF_SIZE = 255;
	char str_file[BUF_SIZE] = {0}; 
	std::ifstream file_stream;

    file_stream.open(filename, std::ios::in);
	if(!file_stream.fail())
	{	
		Rstrings.clear();
     	while( file_stream.getline(str_file, BUF_SIZE))
	    {
		     Rstrings.push_back(str_file);
    	}
    	file_stream.close();
		res = Rstrings.size();
	}
	return(res);
}


EXPFUNC int __stdcall SFile(char *filename,bool ClearArray)
{
	int res = 0;
	fstream fs(filename, ios::out);
	char *noData = "noData";
    if (!fs.bad())
    {	
		if(!Sstrings.empty())
		{
	    	for(int s=0;s<Sstrings.size();s++)
	     	{
            	fs << Sstrings[s].c_str() << endl;
	    	}
		}
		else
		{
		    fs << noData << endl;
		}
		fs.close();
		if(ClearArray){Sstrings.clear();}
    }
	else
	{
	    res = ERROR;
	}
	return(res);
}

EXPFUNC int __stdcall ADDStringFile(char *filename,char* strdata)
{
	int res = 0;
	FILE *file;
	file = fopen(filename, "a+");
    if(file != NULL) 
    {
         fwrite(strdata, sizeof(char), strlen(strdata), file);
		 fclose(file);
    }
	else
	{
	    res = ERROR;
	}
	return(res);
}

EXPFUNC int __stdcall DirCreate(LPCTSTR directoryname)
{
	int err = 0;
	bool res = false;
	res = CreateDirectory(directoryname, NULL);
	if (!res) err = GetLastError();
	return err;
}

EXPFUNC int __stdcall DelFile(char *filename)
{
	int res = 0;
	if(remove(filename)!=0){res=ERROR;}
    return(res);
}